namespace AutoFindlesLootARang
{
    using System;
    using System.Linq;
    using System.Windows.Media;
    using Styx;
    using Styx.Plugins;
    using Styx.Common;
    using Styx.CommonBot;
    using Styx.CommonBot.Frames;
    using Styx.Pathing;
    using Styx.WoWInternals;
    using Styx.WoWInternals.WoWObjects;

    public class AutoFindlesLootARang : HBPlugin
    {
        public override string Name { get { return "Auto Findle's Loot-A-Rang"; } }
        public override string Author { get { return "Proto"; } }
        public override Version Version { get { return new Version(1, 1); } }
        public override bool WantButton { get { return true; } }
        public override string ButtonText { get { return "None"; } }
		public override void OnEnable()
        {
            Logging.Write(Colors.Orange, "Auto Findle's Loot-A-Rang - Enabled");
            base.OnEnable();
        }
        public override void OnDisable()
		{
            Logging.Write(Colors.OrangeRed, "Auto Findle's Loot-A-Rang - Disabled");
            base.OnDisable();
        }
		public static void slog(string format, params object[] args)
        {
            Logging.Write(Colors.Orange, "[AutoLoot]: " + format, args);
        }
        public static WoWItem FindlesLootARangItem;
        private static LocalPlayer Me = StyxWoW.Me;
        private double LootRange
        {
            get { return LootTargeting.LootRadius; }
        }
        private IOrderedEnumerable<WoWUnit> Lootables
        {
            get
            {
                var targetsList = ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(n => (n.Lootable) 
				&& n.Distance <= LootRange).OrderBy(l => l.Distance);
                return targetsList;
            }
        }
        public override void Pulse()
        {
            if (Lootables.Count() == 0)
			{
                return;
            }
            if(!HasFindlesLootARangItem()) 
			{
                return;
            }
            if(!CanUseFindlesLootARang()) 
			{
                return;
            }
            if(IsFindlesLootARangOnCooldown()) 
			{
                return;
            }        
            if (LootFrame.Instance != null 
			&& LootFrame.Instance.IsVisible)
            {
                LootFrame.Instance.LootAll();
				//StyxWoW.Sleep(250);
                return;
            }
            var lootTarget = Lootables.FirstOrDefault();
            if (lootTarget.Distance > 40)
            {
                slog("Moving to loot {0}.", lootTarget.Name);
                Navigator.MoveTo(lootTarget.Location);
                lootTarget.Interact();
				return;
            }
            else
            {
				UseFindlesLootARang();
                return;
            }
        }

        public static bool IsViable(WoWObject pWoWObject) 
		{
            return (pWoWObject != null) 
			&& pWoWObject.IsValid;
        }
		public static bool HasFindlesLootARangItem() 
		{
            FindlesLootARangItem = Me.BagItems.FirstOrDefault(item => item.Entry == 109167);
            return FindlesLootARangItem != null;
        }
        public static bool CanUseFindlesLootARang() 
		{
            return IsViable(Me) 
			&& !Me.IsDead 
			&& !Me.IsChanneling 
			&& !Me.IsCasting 
			&& !Me.IsFlying 
			&& !Me.OnTaxi 
			&& !Me.IsOnTransport 
			&& !Me.InVehicle 
			&& !Me.IsMoving; 
			//&& Targeting.Instance.FirstUnit == null; 
        }
        public static void UseFindlesLootARang() 
		{
            FindlesLootARangItem.Use();
        }
        public static bool IsFindlesLootARangOnCooldown() 
		{
            return FindlesLootARangItem.Cooldown > 0;
        }
    }
}
